#include "mainwindow.h"

RegularCalculator::RegularCalculator(QWidget*parent):QWidget(parent){

    button_0= new QPushButton("0",this);
    button_1= new QPushButton("1",this);
    button_2= new QPushButton("2",this);
    button_3= new QPushButton("3",this);
    button_4= new QPushButton("4",this);
    button_5= new QPushButton("5",this);
    button_6= new QPushButton("6",this);
    button_7= new QPushButton("7",this);
    button_8= new QPushButton("8",this);
    button_9= new QPushButton("9",this);
    button_c= new QPushButton("C",this);
    button_sqrt= new QPushButton("sqrt",this);
    button_1divx= new QPushButton("1/x",this);
    button_equal= new QPushButton("=",this);
    button_divide= new QPushButton("/",this);
    button_multiply= new QPushButton("*",this);
    button_minus= new QPushButton("-",this);
    button_plus= new QPushButton("+",this);
    button_point= new QPushButton(".",this);
    CreateRegularButtons();

    normal_mode= new QRadioButton("обычный",this);
    normal_mode->setChecked(true);
    engineering_mode=new QRadioButton("инженерный",this);

    result=new QLineEdit(this);

    QFont fixedFont = QFontDatabase::systemFont(QFontDatabase::FixedFont);
    fixedFont.setWeight(QFont::Weight::Bold);
    fixedFont.setPointSize(30);
    result->setFont(fixedFont);

    setStyleSheet("QPushButton { max-width: 100px;min-width: 100px; max-height: 100px;min-height: 100px;}");
    button_equal->setStyleSheet("min-width: 100px; min-height: 208px;max-width: 100px; max-height: 208px;");
    button_0->setStyleSheet("min-width: 208px; min-height: 100px;max-width: 208px; max-height: 100px;");
    button_c->setStyleSheet("max-width: 100px;min-width: 100px; max-height: 100px;min-height: 100px;");
    result->setPlaceholderText("0");
    result->setReadOnly(true);
    result->setStyleSheet("max-width: 532px;min-width: 532px; max-height: 50px;min-height: 50px;");
    setWindowTitle("Калькулятор (обычный)");
    result->setAlignment(Qt::AlignRight);

    QVBoxLayout* layout_mode=new QVBoxLayout();
    layout_mode->addWidget(normal_mode);
    layout_mode->addWidget(engineering_mode);
    QHBoxLayout* layout_mode_c=new QHBoxLayout();
    layout_mode_c->addLayout(layout_mode);
    layout_mode_c->addWidget(button_c);

    layout_result=new QVBoxLayout(this);
    layout_result->addWidget(result);
    layout_result->addLayout(layout_mode_c);
    layout_result->addLayout(regular_buttons);
    setLayout(layout_result);

    layout_result->setSizeConstraint(QLayout::SetFixedSize);
    show();
}

void RegularCalculator::CreateRegularButtons(){
    QHBoxLayout* layout1=new QHBoxLayout();
    layout1->addWidget(button_7);
    layout1->addWidget(button_8);
    layout1->addWidget(button_9);
    layout1->addWidget(button_divide);
    layout1->addWidget(button_sqrt);
    QHBoxLayout* layout2=new QHBoxLayout();
    layout2->addWidget(button_4);
    layout2->addWidget(button_5);
    layout2->addWidget(button_6);
    layout2->addWidget(button_multiply);
    layout2->addWidget(button_1divx);
    QHBoxLayout* layout3=new QHBoxLayout();
    layout3->addWidget(button_1);
    layout3->addWidget(button_2);
    layout3->addWidget(button_3);
    layout3->addWidget(button_minus);
    QHBoxLayout* layout4=new QHBoxLayout();
    layout4->addWidget(button_0);
    layout4->addWidget(button_point);
    layout4->addWidget(button_plus);
    QVBoxLayout* layout5=new QVBoxLayout();
    layout5->addLayout(layout3);
    layout5->addLayout(layout4);
    QHBoxLayout* layout6=new QHBoxLayout();
    layout6->addLayout(layout5);
    layout6->addWidget(button_equal);
    regular_buttons=new QVBoxLayout();
    regular_buttons->addLayout(layout1);
    regular_buttons->addLayout(layout2);
    regular_buttons->addLayout(layout6);
}

void EngineeringCalculator::mode_regular(bool a){
    if(a){
        delete button_sinh;
        delete button_cosh;
        delete button_tanh;
        delete button_factorial;
        delete button_sin;
        delete button_cos;
        delete button_tan;
        delete button_pi;
        delete button_exp;
        delete button_ln;
        delete button_lg;
        delete button_sqrt_3;
        delete button_square;
        delete button_cube;
        delete button_degree_y;
        delete button_sqrt_y;

        delete layout_result;
        CreateRegularButtons();

        Interface(true);
    }
}

void EngineeringCalculator::mode_engineering(bool a){
    if(a){
        delete layout_result;
        CreateEngineeringButtons();
        Interface(false);
    }
}

void EngineeringCalculator::Interface(bool regular_mode){

    QVBoxLayout*layout_mode=new QVBoxLayout();
    layout_mode->addWidget(normal_mode);
    layout_mode->addWidget(engineering_mode);
    QHBoxLayout* layout_mode_c=new QHBoxLayout();
    layout_mode_c->addLayout(layout_mode);
    layout_mode_c->addWidget(button_c);

    setStyleSheet("QPushButton { max-width: 100px; min-width: 100px; max-height: 100px; min-height: 100px;}");
    button_equal->setStyleSheet("min-width: 100px; min-height: 208px; max-width: 100px; max-height: 208px;");
    button_0->setStyleSheet("min-width: 208px; min-height: 100px; max-width: 208px; max-height: 100px;");
    button_c->setStyleSheet("max-width: 100px; min-width: 100px; max-height: 100px; min-height: 100px;");

    layout_result=new QVBoxLayout(this);
    layout_result->addWidget(result);
    layout_result->addLayout(layout_mode_c);

    if(regular_mode){
        setWindowTitle(tr("Калькулятор (обычный)"));
        result->setStyleSheet("max-width: 532px;min-width: 532px; max-height: 50px;min-height: 50px;");
        layout_result->addLayout(regular_buttons);
    }
    else{
        setWindowTitle(tr("Калькулятор (инженерный)"));
        result->setStyleSheet("max-width: 964px;min-width: 964px; max-height: 50px;min-height: 50px;");
        layout_result->addLayout(engineering_buttons);
    }
    setLayout(layout_result);
    layout_result->setSizeConstraint(QLayout::SetFixedSize);
    show();
}

EngineeringCalculator::EngineeringCalculator(QWidget *parent):RegularCalculator(parent){

    connect(normal_mode,SIGNAL(toggled(bool)),this,SLOT(mode_regular(bool)));
    connect(engineering_mode,SIGNAL(toggled(bool)),this,SLOT(mode_engineering(bool)));

    connect(button_0,SIGNAL(clicked()),this,SLOT(PushButtons()));
    connect(button_1,SIGNAL(clicked()),this,SLOT(PushButtons()));
    connect(button_2,SIGNAL(clicked()),this,SLOT(PushButtons()));
    connect(button_3,SIGNAL(clicked()),this,SLOT(PushButtons()));
    connect(button_4,SIGNAL(clicked()),this,SLOT(PushButtons()));
    connect(button_5,SIGNAL(clicked()),this,SLOT(PushButtons()));
    connect(button_6,SIGNAL(clicked()),this,SLOT(PushButtons()));
    connect(button_7,SIGNAL(clicked()),this,SLOT(PushButtons()));
    connect(button_8,SIGNAL(clicked()),this,SLOT(PushButtons()));
    connect(button_9,SIGNAL(clicked()),this,SLOT(PushButtons()));
    connect(button_c,SIGNAL(clicked()),this,SLOT(PushButtons()));
    connect(button_sqrt,SIGNAL(clicked()),this,SLOT(PushButtons()));
    connect(button_1divx,SIGNAL(clicked()),this,SLOT(PushButtons()));
    connect(button_equal,SIGNAL(clicked()),this,SLOT(PushButtons()));
    connect(button_divide,SIGNAL(clicked()),this,SLOT(PushButtons()));
    connect(button_multiply,SIGNAL(clicked()),this,SLOT(PushButtons()));
    connect(button_minus,SIGNAL(clicked()),this,SLOT(PushButtons()));
    connect(button_plus,SIGNAL(clicked()),this,SLOT(PushButtons()));
    connect(button_point,SIGNAL(clicked()),this,SLOT(PushButtons()));
}

void EngineeringCalculator::CreateEngineeringButtons(){
    CreateRegularButtons();

    button_sinh= new QPushButton("sinh",this);
    button_cosh= new QPushButton("cosh",this);
    button_tanh= new QPushButton("tanh",this);
    button_factorial= new QPushButton("n!",this);
    button_sin= new QPushButton("sin",this);
    button_cos= new QPushButton("cos",this);
    button_tan= new QPushButton("tan",this);
    button_pi= new QPushButton("П",this);
    button_exp= new QPushButton("exp",this);
    button_ln= new QPushButton("ln",this);
    button_lg= new QPushButton("lg",this);
    button_sqrt_3= new QPushButton("x^(1/3)",this);
    button_square= new QPushButton("x^2",this);
    button_cube= new QPushButton("x^3",this);
    button_degree_y= new QPushButton("x^y",this);
    button_sqrt_y= new QPushButton("x^(1/y)",this);

    connect(button_sinh,SIGNAL(clicked()),this,SLOT(PushButtons()));
    connect(button_cosh,SIGNAL(clicked()),this,SLOT(PushButtons()));
    connect(button_tanh,SIGNAL(clicked()),this,SLOT(PushButtons()));
    connect(button_factorial,SIGNAL(clicked()),this,SLOT(PushButtons()));
    connect(button_sin,SIGNAL(clicked()),this,SLOT(PushButtons()));
    connect(button_cos,SIGNAL(clicked()),this,SLOT(PushButtons()));
    connect(button_tan,SIGNAL(clicked()),this,SLOT(PushButtons()));
    connect(button_pi,SIGNAL(clicked()),this,SLOT(PushButtons()));
    connect(button_exp,SIGNAL(clicked()),this,SLOT(PushButtons()));
    connect(button_ln,SIGNAL(clicked()),this,SLOT(PushButtons()));
    connect(button_lg,SIGNAL(clicked()),this,SLOT(PushButtons()));
    connect(button_sqrt_3,SIGNAL(clicked()),this,SLOT(PushButtons()));
    connect(button_square,SIGNAL(clicked()),this,SLOT(PushButtons()));
    connect(button_cube,SIGNAL(clicked()),this,SLOT(PushButtons()));
    connect(button_degree_y,SIGNAL(clicked()),this,SLOT(PushButtons()));
    connect(button_sqrt_y,SIGNAL(clicked()),this,SLOT(PushButtons()));

    QHBoxLayout* layout_eng_1=new QHBoxLayout();
     layout_eng_1->addWidget(button_sinh);
     layout_eng_1->addWidget(button_sin);
     layout_eng_1->addWidget(button_exp);
     layout_eng_1->addWidget(button_square);
     QHBoxLayout* layout_eng_2=new QHBoxLayout();
     layout_eng_2->addWidget(button_cosh);
     layout_eng_2->addWidget(button_cos);
     layout_eng_2->addWidget(button_ln);
     layout_eng_2->addWidget(button_cube);
     QHBoxLayout* layout_eng_3=new QHBoxLayout();
     layout_eng_3->addWidget(button_tanh);
     layout_eng_3->addWidget(button_tan);
     layout_eng_3->addWidget(button_lg);
     layout_eng_3->addWidget(button_degree_y);
     QHBoxLayout* layout_eng_4=new QHBoxLayout();
     layout_eng_4->addWidget(button_factorial);
     layout_eng_4->addWidget(button_pi);
     layout_eng_4->addWidget(button_sqrt_3);
     layout_eng_4->addWidget(button_sqrt_y);
     QVBoxLayout* layout_eng_5=new QVBoxLayout();
     layout_eng_5->addLayout(layout_eng_1);
     layout_eng_5->addLayout(layout_eng_2);
     layout_eng_5->addLayout(layout_eng_3);
     layout_eng_5->addLayout(layout_eng_4);


     engineering_buttons=new QHBoxLayout();
     engineering_buttons->addLayout(layout_eng_5);
     engineering_buttons->addLayout(regular_buttons);
}

static bool permission_operation=true;
static bool permission_point=true;
static bool permission_number=true;

void EngineeringCalculator::PushButtons(){
    QObject* obj = sender();

    if(obj==button_0 ||obj==button_1 ||obj==button_2 || obj==button_3 || obj==button_4 ||
       obj==button_5 ||obj==button_6 ||obj==button_7 || obj==button_8 ||obj==button_9){     //кнопки с цифрами
        QString str;
        if(permission_number)str=result->text();
        else{
            button_c->click();
            str="";
        }
        if(obj==button_0) result->setText(str+'0');
        if(obj==button_1) result->setText(str+'1');
        if(obj==button_2) result->setText(str+'2');
        if(obj==button_3) result->setText(str+'3');
        if(obj==button_4) result->setText(str+'4');
        if(obj==button_5) result->setText(str+'5');
        if(obj==button_6) result->setText(str+'6');
        if(obj==button_7) result->setText(str+'7');
        if(obj==button_8) result->setText(str+'8');
        if(obj==button_9) result->setText(str+'9');
    }

    if(obj==button_c){         //кнопка С
        result->setText("");
        permission_number=true;
        permission_operation=true;
        permission_point=true;
    }

    if(obj==button_pi){       //кнопка pi
        if(permission_operation){
            button_c->click();
            result->setText("3.1415926");
        }
        else{
            QString str=result->text();
            if(str.indexOf("/")!=-1){
                QStringList number=str.split('/');
                result->setText(number[0]+'/'+"3.1415926");
            }
            if(str.indexOf("*")!=-1){
                QStringList number=str.split('*');
                result->setText(number[0]+'*'+"3.1415926");
            }
            if(str.indexOf("+")!=-1){
                QStringList number=str.split('+');
                result->setText(number[0]+'+'+"3.1415926");
            }
            if(str.indexOf("-")!=-1){
                QStringList number=str.split('-');
                result->setText(number[0]+'-'+"3.1415926");
            }
            if(str.indexOf("^")!=-1){
                QStringList number=str.split('^');
                result->setText(number[0]+'^'+"3.1415926");
            }
            if(str.indexOf("^(1/")!=-1){
                QStringList number=str.split("^(1/");
                result->setText(number[0]+"^(1/"+"3.1415926");
            }
            permission_number=false;
            permission_point=false;
        }
    }

    if(obj==button_point && permission_point==true){     //кнопка .
        QString str=result->text();
        if(str!=Q_NULLPTR)result->setText(str+'.');
        else result->setText("0.");
        permission_point=false;
    }

    if(obj==button_sqrt || obj==button_1divx || obj==button_sinh || obj==button_cosh ||
       obj==button_tanh || obj==button_factorial || obj==button_sin || obj==button_cos ||
       obj==button_tan || obj==button_exp || obj==button_ln || obj==button_lg ||
       obj==button_sqrt_3 || obj==button_square || obj==button_cube){               //кнопки с унарными операциями
        if(!permission_operation) button_equal->click();
        QString str=result->text();
        if (str==Q_NULLPTR) str="0";

        double number=str.toDouble();
        if(obj==button_sqrt && number>=0) result->setText(QString::number(qSqrt(number),'g',10));
        else if(obj==button_1divx && number!=0) result->setText(QString::number(1/(number),'g',10));
        else if(obj==button_sinh) result->setText(QString::number((qExp(number)-qExp(-number))/2,'g',10));
        else if(obj==button_cosh) result->setText(QString::number((qExp(number)+qExp(-number))/2,'g',10));
        else if(obj==button_tanh) result->setText(QString::number((1-qExp(-2*number))/(1+qExp(-2*number)),'g',10));
        else if(obj==button_factorial && number>=0 && number==int(number)) {
            if (number==0) result->setText("1");
            else{
            int res=1;
            for(int i=1;i<=int(number);++i){
                res*=i;
            }
            result->setText(QString::number(res,'g',10));
            }
        }
        else if(obj==button_factorial && number>=0 && number!=int(number)) {
            double res2=1;
            for(int i=1;i<=int(number);++i){
                res2*=i;
            }
            res2=qLn(res2)/qLn(10)+(number-int(number))*qLn(int(number)+1)/qLn(10);
            result->setText(QString::number(res2,'g',10));
        }
        else if(obj==button_sin) result->setText(QString::number(qSin(number),'g',10));
        else if(obj==button_cos) result->setText(QString::number(qCos(number),'g',10));
        else if(obj==button_tan) result->setText(QString::number(qTan(number),'g',10));
        else if(obj==button_exp) result->setText(QString::number(qExp(number),'g',10));
        else if(obj==button_ln && number>0) result->setText(QString::number(qLn(number),'g',10));
        else if(obj==button_lg && number>0) result->setText(QString::number(qLn(number)/qLn(10),'g',10));
        else if(obj==button_sqrt_3) result->setText(QString::number(qPow(number,1/3),'g',10));
        else if(obj==button_square) result->setText(QString::number(qPow(number,2),'g',10));
        else if(obj==button_cube) result->setText(QString::number(qPow(number,3),'g',10));
        else {
            result->setText("Неверный ввод");
            permission_operation=false;
        }
        permission_number=false;
        permission_point=false;
    }

    if((obj==button_divide ||obj==button_multiply || obj==button_minus ||
        obj==button_plus || obj==button_degree_y || obj==button_sqrt_y)){     //кнопки с бинарными операциями
        if(permission_operation==false) button_equal->click();
        QString str=result->text();
        if(str==Q_NULLPTR) str="0";
        if(obj==button_divide) result->setText(str+"/");
        if(obj==button_multiply) result->setText(str+"*");
        if(obj==button_minus) result->setText(str+"-");
        if(obj==button_plus) result->setText(str+"+");
        if(obj==button_degree_y) result->setText(str+"^");
        if(obj==button_sqrt_y) result->setText(str+"^(1/");
        permission_operation=false;
        permission_point=true;
        permission_number=true;
    }

    if(obj==button_equal && permission_operation==false){                                 //кнопка =

            QString str=result->text();
            if(str.indexOf("/")!=-1){
                QStringList numbers=str.split(QLatin1Char('/'));
                if (numbers[1]!="0"){
                    result->setText(QString::number((numbers[0].toDouble())/(numbers[1].toDouble()),'g',10));
                    permission_operation=true;
                }
                else{
                    result->setText("Неверный ввод");
                    permission_operation=false;
                }
            }
            if(str.indexOf("*")!=-1){
                QStringList numbers=str.split(QLatin1Char('*'));
                result->setText(QString::number((numbers[0].toDouble())*(numbers[1].toDouble()),'g',10));
                permission_operation=true;
            }
            if(str.indexOf("+")!=-1){
                QStringList numbers=str.split(QLatin1Char('+'));
                result->setText(QString::number(numbers[0].toDouble()+numbers[1].toDouble(),'g',10));
                permission_operation=true;
            }
            if(str.indexOf("-")!=-1){
                QStringList numbers=str.split(QLatin1Char('-'));
                result->setText(QString::number(numbers[0].toDouble()-numbers[1].toDouble(),'g',10));
                permission_operation=true;
            }
            if(str.indexOf("^")!=-1){
                QStringList numbers=str.split(QLatin1Char('^'));
                if(numbers[1].toDouble()>=0){
                    result->setText(QString::number(qPow(numbers[0].toDouble(),numbers[1].toDouble()),'g',10));
                    permission_operation=true;
                }
                else{
                    result->setText("Неверный ввод");
                    permission_operation=false;
                }
            }
            if(str.indexOf("^(1/")!=-1){
                QStringList numbers=str.split(QLatin1String("^(1/"));
                if(numbers[1].toDouble()>0){
                    result->setText(QString::number(qPow(numbers[0].toDouble(),1/(numbers[1].toDouble())),'g',10));
                    permission_operation=true;
                }
                else{
                    result->setText("Неверный ввод");
                    permission_operation=false;
                }
            }
            permission_point=false;
            permission_number=false;
        }
}
